using System;
using System.Collections.Generic;
using System.Text;

namespace Meebo
{
    class CssStyle
    {
        // parts of code taken from 
        // http://codebetter.com/blogs/brendan.tompkins/archive/2003/10/23/2827.aspx

        private Dictionary<string, string> styles = new Dictionary<string, string>();

        public CssStyle(string cssStyle)
        {
            if (cssStyle != null)
            {
                string[] keyvals = cssStyle.Split(new char[1] { ';' });
                foreach (string keyvalpair in keyvals)
                {
                    string[] keyVal = keyvalpair.Split(new char[1] { ':' }, 2);
                    if (keyVal.Length == 2)
                    {
                        styles.Add(keyVal[0].Trim().ToLower(), keyVal[1].Trim().ToLower());
                    }
                }
            }
        }

        public override string ToString()
        {
            if (styles.Count == 0) return null;
            string style = "";
            foreach (string key in styles.Keys)
            {
                style += key + ":" + styles[key] + ";";
            }
            return style;
        }

        public string this[string key]
        {
            get
            {
                if (styles.ContainsKey(key.ToLower()))
                {
                    return styles[key.ToLower()];
                }
                else
                {
                    return null;
                }
            }
            set
            {
                if (value != null)
                {
                    styles[key.ToLower()] = value.ToLower();
                }
                else
                {
                    styles.Remove(key.ToLower());
                }
            }
        }
    }
}
