using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.Windows.Forms;

using Meebo.Properties;

namespace Meebo
{

    class DynamicWebBrowser : WebBrowser
    {
        public DynamicWebBrowser()
        {
            Guid clsid = ((GuidAttribute)typeof(EngineEnum).GetField(Settings.Default.Engine.ToString()).GetCustomAttributes(typeof(GuidAttribute), false)[0]).Value;
            typeof(WebBrowserBase).InvokeMember("clsid", BindingFlags.SetField | BindingFlags.Instance | BindingFlags.NonPublic, null, this, new object[] { clsid });
        }
    }

    public enum EngineEnum
    {
        [Guid("8856f961-340a-11d0-a96b-00c04fd705a2")]
        Microsoft = 1,
        [Guid("1339b54c-3453-11d2-93b9-000000000000")]
        Mozilla = 2
    }

    [AttributeUsage(AttributeTargets.Field, Inherited = false)]
    public sealed class GuidAttribute : Attribute
    {
        // Methods
        public GuidAttribute(string guid)
        {
            this._val = new Guid(guid);
        }

        // Properties
        public Guid Value
        {
            get
            {
                return this._val;
            }
        }

        // Fields
        internal Guid _val;
    }
}
